#ifndef SUCCESSOR_GENERATOR_H
#define SUCCESSOR_GENERATOR_H

#include "state.h"

#include <iostream>
#include <vector>

class Operator;

class SuccessorGenerator {
public:
    virtual ~SuccessorGenerator() {}
    
    // standard function used for branching in search
    virtual void generate_applicable_ops(const State &curr, std::vector<const Operator *> &ops) = 0;
    
    // used to saturate redblack states
    virtual void generate_applicable_ops(const PackedStateBin *buffer, std::vector<const Operator *> &ops) = 0;
                                         
    void dump() {_dump("  "); }
    virtual void _dump(std::string indent) = 0;
};

SuccessorGenerator *read_successor_generator(std::istream &in);

#endif
